package corbaTrace.log2xmi;

import javax.xml.parsers.SAXParserFactory;
import javax.xml.parsers.ParserConfigurationException;
import javax.xml.parsers.SAXParser;
import org.xml.sax.helpers.DefaultHandler;

import java.io.InputStream;

/**
 *
 * @author Nicolas Lemoullec
 * @author Antoine Parra del Pozo
 */
public class LogSaxParser {
    
    // attributes
    private DefaultHandler handler;
    private SAXParser saxParser;

    // constructor
    public LogSaxParser(DefaultHandler saxHandler) {
	this("", saxHandler);
    }
    
    public LogSaxParser(String parserClassName, DefaultHandler saxHandler) {
        try {
	    handler = saxHandler;  // Use an instance of our handler as the SAX event handler

	    //create a SAX parser depending on sax implementation class choosen by user.
	    if ((parserClassName == null) || (parserClassName.length() <= 0)) {
		// use default parser in that case
		SAXParserFactory factory = SAXParserFactory.newInstance();
		// uses a validating XML parser (to use with a DTD)
		factory.setValidating(true); 
		// Parse the input
		saxParser = factory.newSAXParser();
	    } else {
		//XXXXXXXXXXXXX si on veut dfinir notre propre implmentation du parser (ou une autre que celle utilise par dfaut avec le JDK)
	    }

	} catch (org.xml.sax.SAXParseException e) {
	    System.err.println(">>> error while parsing (org.xml.sax.SAXParseException), line "+e.getLineNumber()
			       +", uri "+e.getSystemId()+"   "+e.getMessage());
	    if (e.getException() != null)
		((Exception)e.getException()).printStackTrace();
        } catch (org.xml.sax.SAXException e) {
            System.err.println(">>> error while parsing (org.xml.sax.SAXException) : "+e.getMessage());
           if (e.getException() != null)
               ((Exception)e.getException()).printStackTrace();
        } catch (javax.xml.parsers.ParserConfigurationException e) {
            System.err.println(">>> configuration error : javax.xml.parsers.ParserConfigurationException\n" + e.getMessage());
            System.exit(1);
        }
	
    }
    
    public void startParsingFile(InputStream log)
        throws java.io.IOException, org.xml.sax.SAXException {
	saxParser.parse(log, handler);
    }
    
}
