package corbaTrace.xmi;

import org.w3c.dom.*;
import com.sun.xml.tree.XmlDocument;

public class XmiCallAction{

  private Element me;
  private XmiDocument doc;
  private String name;
  private String gid;
    private XmiOperation operation;

  public XmiCallAction(XmiDocument doc, String name, XmiOperation request){
    this.doc=doc;
    this.name=name;
    this.operation=request;
    initCallAction(name, request);
  }

  public Element getElement(){
    return this.me;
  }

  public String getGid(){
    return this.gid;
  }

  public String getName(){
    return this.name;
  }

    public XmiOperation getOperation(){
	return this.operation;
    }

  private void initCallAction(String name, XmiOperation request){
    /**
    <Behavioral_Elements.Common_Behavior.CallAction xmi.id = 'G.15'>
      <Foundation.Core.ModelElement.name>operation1( )</Foundation.Core.ModelElement.name>
      <Foundation.Core.ModelElement.visibility xmi.value = 'private'/>
      <Behavioral_Elements.Common_Behavior.Action.recurrence>
         <Foundation.Data_Types.Expression>
          <Foundation.Data_Types.Expression.language></Foundation.Data_Types.Expression.language>
          <Foundation.Data_Types.Expression.body></Foundation.Data_Types.Expression.body>
         </Foundation.Data_Types.Expression>
      </Behavioral_Elements.Common_Behavior.Action.recurrence>
      <Behavioral_Elements.Common_Behavior.Action.target>
         <Foundation.Data_Types.ObjectSetExpression>
          <Foundation.Data_Types.Expression.language></Foundation.Data_Types.Expression.language>
          <Foundation.Data_Types.Expression.body></Foundation.Data_Types.Expression.body>
         </Foundation.Data_Types.ObjectSetExpression>
      </Behavioral_Elements.Common_Behavior.Action.target>
      <Behavioral_Elements.Common_Behavior.Action.isAsynchronous xmi.value = 'true'/>
      <Behavioral_Elements.Common_Behavior.Action.script>
      </Behavioral_Elements.Common_Behavior.Action.script>
      <Behavioral_Elements.Common_Behavior.CallAction.mode xmi.value = 'asynchronous'/>
      <Behavioral_Elements.Common_Behavior.Action.request>
        <Foundation.Core.Operation xmi.idref = 'S.10002'/> <!-- operation1 -->
      </Behavioral_Elements.Common_Behavior.Action.request>
    </Behavioral_Elements.Common_Behavior.CallAction>
    **/

      this.me=doc.createElement("Behavioral_Elements.Common_Behavior.SendAction"); //It was originally a CallAction in Unisys
    this.gid=doc.getUniqueGid();
    this.me.setAttribute("xmi.id",this.gid);
    Element elem=doc.createElement("Foundation.Core.ModelElement.name");
    this.me.appendChild(elem);
    elem.appendChild(doc.createTextNode(name));
    elem=doc.createElement("Foundation.Core.ModelElement.visibility");
    elem.setAttribute("xmi.value","private");
    this.me.appendChild(elem);
    elem=doc.createElement("Behavioral_Elements.Common_Behavior.Action.recurrence");
    this.me.appendChild(elem);
    Element elem2=doc.createElement("Foundation.Data_Types.Expression");
    elem.appendChild(elem2);
    Element elem3=doc.createElement("Foundation.Data_Types.Expression.language");
    elem2.appendChild(elem3);
    elem3=doc.createElement("Foundation.Data_Types.Expression.body");
    elem2.appendChild(elem3);
    elem=doc.createElement("Behavioral_Elements.Common_Behavior.Action.target");
    this.me.appendChild(elem);
    elem2=doc.createElement("Foundation.Data_Types.ObjectSetExpression");
    elem.appendChild(elem2);
    elem3=doc.createElement("Foundation.Data_Types.Expression.language");
    elem2.appendChild(elem3);
    elem3=doc.createElement("Foundation.Data_Types.Expression.body");
    elem2.appendChild(elem3);
    elem=doc.createElement("Behavioral_Elements.Common_Behavior.Action.isAsynchronous");
    elem.setAttribute("xmi.value","false");
    this.me.appendChild(elem);
    elem=doc.createElement("Behavioral_Elements.Common_Behavior.Action.script");
    this.me.appendChild(elem);
    elem=doc.createElement("Behavioral_Elements.Common_Behavior.CallAction.mode");
    elem.setAttribute("xmi.value","asynchronous");
    this.me.appendChild(elem);
    elem=doc.createElement("Behavioral_Elements.Common_Behavior.Action.request");
    this.me.appendChild(elem);
    elem2=doc.createElement("Foundation.Core.Operation");
    elem2.setAttribute("xmi.idref",request.getSid());
    elem.appendChild(elem2);
  }
}
