package corbaTrace.xmi;

import org.w3c.dom.*;
import com.sun.xml.tree.XmlDocument;
import java.util.Vector;

public class XmiClass{
  private Element me;
  private String name;
  private XmiDocument doc;
  private Element operationParent;
  private Vector operations;
  private String sid;
  private Element namespaceElement;

  public XmiClass(XmiDocument doc, String name){
    this.name=name;
    this.doc=doc;
    this.operations=new Vector();

    initClass(name);
  }

  public String getSid(){
    return this.sid;
  }

  public String getName(){
    return this.name;
  }

  public Element getElement(){
    return this.me;
  }

  public Vector getOperations(){
    return this.operations;
  }

  public void setNamespaceRef(String ref){
    this.namespaceElement.setAttribute("xmi.idref",ref);
  }

  private void initClass(String name){
    /**
    <Foundation.Core.Class xmi.id = 'S.10001'>
      <Foundation.Core.ModelElement.name>Objet2</Foundation.Core.ModelElement.name>
      <Foundation.Core.ModelElement.visibility xmi.value = 'public'/>
      <Foundation.Core.GeneralizableElement.isRoot xmi.value = 'true'/>
      <Foundation.Core.GeneralizableElement.isLeaf xmi.value = 'true'/>
      <Foundation.Core.GeneralizableElement.isAbstract xmi.value = 'false'/>
      <Foundation.Core.Class.isActive xmi.value = 'false'/>
      <Foundation.Core.ModelElement.namespace>
        <Model_Management.Model xmi.idref = 'G.1'/> <!-- ExempleRose2 -->
      </Foundation.Core.ModelElement.namespace>
      <Foundation.Core.ModelElement.taggedValue>
        <Foundation.Extension_Mechanisms.TaggedValue>
          <Foundation.Extension_Mechanisms.TaggedValue.tag>
            persistence
          </Foundation.Extension_Mechanisms.TaggedValue.tag>
          <Foundation.Extension_Mechanisms.TaggedValue.value>
            transient
          </Foundation.Extension_Mechanisms.TaggedValue.value>
        </Foundation.Extension_Mechanisms.TaggedValue>
      </Foundation.Core.ModelElement.taggedValue>
      <Foundation.Core.Classifier.feature>

        //addOperation ici

      </Foundation.Core.Classifier.feature>
    </Foundation.Core.Class>
    **/

    this.me=doc.createElement("Foundation.Core.Class");
    this.sid=this.doc.getUniqueSid();
    this.me.setAttribute("xmi.id",this.sid);
    Element elem2=doc.createElement("Foundation.Core.ModelElement.name");
    elem2.appendChild(doc.createTextNode(name));
    this.me.appendChild(elem2);
    elem2=doc.createElement("Foundation.Core.ModelElement.visibility");
    elem2.setAttribute("xmi.value","public");
    this.me.appendChild(elem2);
    elem2=doc.createElement("Foundation.Core.GeneralizableElement.isRoot");
    elem2.setAttribute("xmi.value","true");
    this.me.appendChild(elem2);
    elem2=doc.createElement("Foundation.Core.GeneralizableElement.isLeaf");
    elem2.setAttribute("xmi.value","true");
    this.me.appendChild(elem2);
    elem2=doc.createElement("Foundation.Core.GeneralizableElement.isAbstract");
    elem2.setAttribute("xmi.value","false");
    this.me.appendChild(elem2);
    elem2=doc.createElement("Foundation.Core.Class.isActive");
    elem2.setAttribute("xmi.value","false");
    this.me.appendChild(elem2);
    elem2=doc.createElement("Foundation.Core.ModelElement.namespace");
    this.me.appendChild(elem2);
    this.namespaceElement=doc.createElement("Model_Management.Model");
    this.namespaceElement.setAttribute("xmi.idref",""); //left empty until the class is added to a model
    elem2.appendChild(this.namespaceElement);

    elem2=doc.createElement("Foundation.Core.ModelElement.taggedValue");
    this.me.appendChild(elem2);
    Element elem3=doc.createElement("Foundation.Extension_Mechanisms.TaggedValue");
    elem2.appendChild(elem3);
    Element elem4=doc.createElement("Foundation.Extension_Mechanisms.TaggedValue.tag");
    elem4.appendChild(doc.createTextNode("persistence"));
    elem3.appendChild(elem4);
    elem4=doc.createElement("Foundation.Extension_Mechanisms.TaggedValue.value");
    elem4.appendChild(doc.createTextNode("transient"));
    elem3.appendChild(elem4);

    this.operationParent=doc.createElement("Foundation.Core.Classifier.feature");
    this.me.appendChild(this.operationParent);

  }

  public void addOperation(XmiOperation operation){
    this.operationParent.appendChild(operation.getElement());
    this.operations.addElement(operation);
  }

}