package corbaTrace.xmi;

import org.w3c.dom.*;
import com.sun.xml.tree.XmlDocument;

public class XmiMessage{
  private String gid;
  private XmiDocument doc;
  private String name;
  private Element me;
  private Element afterPrecSuc;
  private XmiClassifierRole sender;
  private XmiClassifierRole receiver;
  private XmiCallAction callAction;

  public XmiMessage(XmiDocument doc, String name, XmiClassifierRole sender, XmiClassifierRole receiver, XmiCallAction action){
    this.doc=doc;
    this.name=name;
    this.sender=sender;
    this.receiver=receiver;
    initMessage(action);
    this.callAction=action;
  }

    public XmiCallAction getCallAction(){
	return this.callAction;
    }

  public Element getElement(){
    return this.me;
  }

  public XmiClassifierRole getSender(){
    return this.sender;
  }

  public XmiClassifierRole getReceiver(){
    return this.receiver;
  }

  public String getGid(){
    return this.gid;
  }

  private void initMessage(XmiCallAction action){
    /**
    <Behavioral_Elements.Collaborations.Message xmi.id = 'G.10'>
      <Foundation.Core.ModelElement.name>operation1( )</Foundation.Core.ModelElement.name>
      <Foundation.Core.ModelElement.visibility xmi.value = 'private'/>
      
        //setPredecessor here

        //setSuccessor ici

      <Behavioral_Elements.Collaborations.Message.action>
        <Behavioral_Elements.Common_Behavior.CallAction xmi.idref = 'G.16'/> <!-- operation1( ) -->
      </Behavioral_Elements.Collaborations.Message.action>
      <Behavioral_Elements.Collaborations.Message.receiver>
        <Behavioral_Elements.Collaborations.ClassifierRole xmi.idref = 'G.7'/> <!-- InstanceObjet3 -->
      </Behavioral_Elements.Collaborations.Message.receiver>
      <Behavioral_Elements.Collaborations.Message.sender>
        <Behavioral_Elements.Collaborations.ClassifierRole xmi.idref = 'G.5'/> <!-- InstanceObjet2 -->
      </Behavioral_Elements.Collaborations.Message.sender>
    </Behavioral_Elements.Collaborations.Message>
    **/

    this.me=doc.createElement("Behavioral_Elements.Collaborations.Message");
    this.gid=doc.getUniqueGid();
    this.me.setAttribute("xmi.id",this.gid);
    Element elem=doc.createElement("Foundation.Core.ModelElement.name");
    elem.appendChild(doc.createTextNode(this.name));
    this.me.appendChild(elem);
    elem=doc.createElement("Foundation.Core.ModelElement.visibility");
    elem.setAttribute("xmi.value","private");
    this.me.appendChild(elem);

    this.afterPrecSuc=doc.createElement("Behavioral_Elements.Collaborations.Message.action");
    this.me.appendChild(this.afterPrecSuc);
    elem=doc.createElement("Behavioral_Elements.Common_Behavior.CallAction");
    elem.setAttribute("xmi.idref",action.getGid());
    this.afterPrecSuc.appendChild(elem);
    elem=doc.createElement("Behavioral_Elements.Collaborations.Message.receiver");
    this.me.appendChild(elem);
    Element elem2=doc.createElement("Behavioral_Elements.Collaborations.ClassifierRole");
    elem2.setAttribute("xmi.idref",this.receiver.getGid());
    elem.appendChild(elem2);
    elem=doc.createElement("Behavioral_Elements.Collaborations.Message.sender");
    this.me.appendChild(elem);
    elem2=doc.createElement("Behavioral_Elements.Collaborations.ClassifierRole");
    elem2.setAttribute("xmi.idref",this.sender.getGid());
    elem.appendChild(elem2);
  }

  public void setSuccessor(XmiMessage successor){
    /**
    <Behavioral_Elements.Collaborations.Message.message>
      <Behavioral_Elements.Collaborations.Message xmi.idref = 'G.11'/> <!-- operation1(Boolean) -->
    </Behavioral_Elements.Collaborations.Message.message>
    **/
    Element elem=doc.createElement("Behavioral_Elements.Collaborations.Message.message");
    Element elem2=doc.createElement("Behavioral_Elements.Collaborations.Message");
    elem2.setAttribute("xmi.idref",successor.getGid());
    elem.appendChild(elem2);
    this.me.insertBefore(elem,this.afterPrecSuc);
    this.afterPrecSuc=elem;
  }

    public void setPredecessor(XmiMessage predecessor){
      /**
       <Behavioral_Elements.Collaborations.Message.predecessor>
        <Behavioral_Elements.Collaborations.Message xmi.idref = 'G.9'/> <!-- operation1( ) -->
      </Behavioral_Elements.Collaborations.Message.predecessor>
      **/
      Element elem,elem2;
      elem=doc.createElement("Behavioral_Elements.Collaborations.Message.predecessor");
      elem2=doc.createElement("Behavioral_Elements.Collaborations.Message");
      elem2.setAttribute("xmi.idref",predecessor.getGid());
      elem.appendChild(elem2);
      this.me.insertBefore(elem,this.afterPrecSuc);
    
    }
}
