package corbaTrace.xmi;

import org.w3c.dom.*;
import com.sun.xml.tree.XmlDocument;
import java.util.HashMap;

public class XmiModel {
  private Element me;
  private XmiDocument doc;
  private String gid;

  private Element classParent;
  private XmiSequenceDiagram seqDiag;

  public XmiModel(XmiDocument doc, String name){
    this.doc=doc;
    initModel(name);
  }

  public Element getElement(){
    return this.me;
  }

  public XmiSequenceDiagram getSeqDiag(){
    return this.seqDiag;
  }

  public String getGid(){
    return this.gid;
  }

  private void initModel(String name){
    /**
    <Model_Management.Model xmi.id = 'G.1'>
      <Foundation.Core.ModelElement.name>ExempleRose2</Foundation.Core.ModelElement.name>
      <Foundation.Core.ModelElement.visibility xmi.value = 'private'/>
      <Foundation.Core.GeneralizableElement.isRoot xmi.value = 'false'/>
      <Foundation.Core.GeneralizableElement.isLeaf xmi.value = 'false'/>
      <Foundation.Core.GeneralizableElement.isAbstract xmi.value = 'false'/>
      <XMI.extension xmi.extender = 'Unisys.IntegratePlus.2'>
        <XMI.reference xmi.idref = 'G.18'/>
      </XMI.extension>
      <Foundation.Core.Namespace.ownedElement>

      //addClass ici
      //addDatatypeEnumeration ici
      //addSequenceDiagram ici
      //addCallAction ici

      </Foundation.Core.Namespace.ownedElement>
    </Model_Management.Model>
    **/

    this.me=doc.createElement("Model_Management.Model");
    this.gid=doc.getUniqueGid();
    this.me.setAttribute("xmi.id",this.gid );
    Element elem2=doc.createElement("Foundation.Core.ModelElement.name");
    elem2.appendChild(doc.createTextNode(name));
    this.me.appendChild(elem2);
    elem2=doc.createElement("Foundation.Core.ModelElement.visibility");
    elem2.setAttribute("xmi.value","private");
    this.me.appendChild(elem2);
    elem2=doc.createElement("Foundation.Core.GeneralizableElement.isRoot");
    elem2.setAttribute("xmi.value","false");
    this.me.appendChild(elem2);
    elem2=doc.createElement("Foundation.Core.GeneralizableElement.isLeaf");
    elem2.setAttribute("xmi.value","false");
    this.me.appendChild(elem2);
    elem2=doc.createElement("Foundation.Core.GeneralizableElement.isAbstract");
    elem2.setAttribute("xmi.value","false");
    this.me.appendChild(elem2);
    this.classParent=doc.createElement("Foundation.Core.Namespace.ownedElement");
    this.me.appendChild(this.classParent);
  }

  public void addClass(XmiClass theClass){
    theClass.setNamespaceRef(this.gid);
    this.classParent.insertBefore(theClass.getElement(), this.classParent.getFirstChild());
  }

  public void addSequenceDiagram(XmiSequenceDiagram diagram){
    this.classParent.appendChild(diagram.getElement());
    this.seqDiag=diagram; //we work only with one diagram in this version
  }

  public void addCallAction(XmiCallAction action){
    this.classParent.appendChild(action.getElement());
  }

  public void addExtensionReference(String gid){
    /**
    <XMI.extension xmi.extender = 'Unisys.IntegratePlus.2'>
      <XMI.reference xmi.idref = 'G.18'/>
    </XMI.extension>
    **/
    Element elem=doc.createElement("XMI.extension");
    elem.setAttribute("xmi.extender","Unisys.IntegratePlus.2");
    Element elem2=doc.createElement("XMI.reference");
    elem2.setAttribute("xmi.idref",gid);
    elem.appendChild(elem2);
    this.me.insertBefore(elem,this.classParent);
  }

  public void addDatatypeEnumeration(String name, String visibility, boolean isRoot, boolean isLeaf, boolean isAbstract, String[] Enumeration){
    //NOT USED YET

    //ceci s'ajoute au mme niveau que les classes

    /**
    <Foundation.Data_Types.Enumeration xmi.id = 'G.13'>
      <Foundation.Core.ModelElement.name>Boolean</Foundation.Core.ModelElement.name>
      <Foundation.Core.ModelElement.visibility xmi.value = 'private'/>
      <Foundation.Core.GeneralizableElement.isRoot xmi.value = 'false'/>
      <Foundation.Core.GeneralizableElement.isLeaf xmi.value = 'false'/>
      <Foundation.Core.GeneralizableElement.isAbstract xmi.value = 'false'/>
      <Foundation.Data_Types.Enumeration.literal>
        <Foundation.Data_Types.EnumerationLiteral>
          <Foundation.Data_Types.EnumerationLiteral.name>
            false
          </Foundation.Data_Types.EnumerationLiteral.name>
        </Foundation.Data_Types.EnumerationLiteral>
        <Foundation.Data_Types.EnumerationLiteral>
          <Foundation.Data_Types.EnumerationLiteral.name>
            true
          </Foundation.Data_Types.EnumerationLiteral.name>
        </Foundation.Data_Types.EnumerationLiteral>
      </Foundation.Data_Types.Enumeration.literal>
    </Foundation.Data_Types.Enumeration>

    **/

  }
}