package corbaTrace.xmi;

import org.w3c.dom.*;
import com.sun.xml.tree.XmlDocument;

public class XmiOperation{
  private String sid;
  private Element me;
  private XmiDocument doc;
  private String name;

  private Element argumentParent; //not used yet but already initialized

  public XmiOperation(XmiDocument doc, String name){
    this.doc=doc;
    this.name=name;
    initOperation(name);
  }

  public Element getElement(){
    return this.me;
  }

  public String getSid(){
    return this.sid;
  }

  public String getName(){
    return this.name;
  }

  private void initOperation(String name){

    /**
    <Foundation.Core.Operation xmi.id = 'S.10002'>
      <Foundation.Core.ModelElement.name>operation1</Foundation.Core.ModelElement.name>
      <Foundation.Core.ModelElement.visibility xmi.value = 'public'/>
      <Foundation.Core.Feature.ownerScope xmi.value = 'instance'/>
      <Foundation.Core.BehavioralFeature.isQuery xmi.value = 'false'/>
      <Foundation.Core.Operation.specification></Foundation.Core.Operation.specification>
      <Foundation.Core.Operation.isPolymorphic xmi.value = 'false'/>
      <Foundation.Core.Operation.concurrency xmi.value = 'sequential'/>
      <Foundation.Core.BehavioralFeature.parameter>

        //addArgument ici

      </Foundation.Core.BehavioralFeature.parameter>
    </Foundation.Core.Operation>
    **/

    this.me=doc.createElement("Foundation.Core.Operation");
    this.sid=doc.getUniqueSid();
    this.me.setAttribute("xmi.id",this.sid);
    Element elem=doc.createElement("Foundation.Core.ModelElement.name");
    elem.appendChild(doc.createTextNode(name));
    this.me.appendChild(elem);
    elem=doc.createElement("Foundation.Core.ModelElement.visibility");
    elem.setAttribute("xmi.value","public");
    this.me.appendChild(elem);
    elem=doc.createElement("Foundation.Core.Feature.ownerScope");
    elem.setAttribute("xmi.value","instance");
    this.me.appendChild(elem);
    elem=doc.createElement("Foundation.Core.BehavioralFeature.isQuery");
    elem.setAttribute("xmi.value","false");
    this.me.appendChild(elem);
    elem=doc.createElement("Foundation.Core.Operation.specification");
    this.me.appendChild(elem);
    elem=doc.createElement("Foundation.Core.Operation.isPolymorphic");
    elem.setAttribute("xmi.value","false");
    this.me.appendChild(elem);
    elem=doc.createElement("Foundation.Core.Operation.concurrency");
    elem.setAttribute("xmi.value","sequential");
    this.me.appendChild(elem);
    this.argumentParent=doc.createElement("Foundation.Core.BehavioralFeature.parameter");
    this.me.appendChild(this.argumentParent);
  }

  public void addArgument(String name, String kind){
    //NOT USED YET
    /**
        <Foundation.Core.Parameter xmi.id = 'G.12'>
          <Foundation.Core.ModelElement.name>arg1</Foundation.Core.ModelElement.name>
          <Foundation.Core.ModelElement.visibility xmi.value = 'private'/>
          <Foundation.Core.Parameter.defaultValue>
             <Foundation.Data_Types.Expression>
              <Foundation.Data_Types.Expression.language></Foundation.Data_Types.Expression.language>
              <Foundation.Data_Types.Expression.body></Foundation.Data_Types.Expression.body>
             </Foundation.Data_Types.Expression>
          </Foundation.Core.Parameter.defaultValue>
          <Foundation.Core.Parameter.kind xmi.value = 'inout'/>
          <Foundation.Core.Parameter.type>
            <Foundation.Data_Types.Enumeration xmi.idref = 'G.13'/> <!-- Boolean -->
          </Foundation.Core.Parameter.type>
        </Foundation.Core.Parameter>
    **/
  }

}